import unittest
import main

class TestMain(unittest.TestCase):

    def test_convert_login_count(self):
        url_server = "https://localhost/vidjil/"
        data = [{'_extra': {'COUNT(`auth_event`.`id`)': 3}, 'auth_event': {'description': 'User 1 Logged-in', 'user_id': 1}, 'auth_user': {'email': 'plop@plop.com'}}, {'_extra': {'COUNT(`auth_event`.`id`)': 1275}, 'auth_event': {'description': 'User 2 Logged-in', 'user_id': 2}, 'auth_user': {'email': 'metrics@vidjil.org'}}, {'_extra': {'COUNT(`auth_event`.`id`)': 14}, 'auth_event': {'description': 'User 3 Logged-in', 'user_id': 3}, 'auth_user': {'email': 'user1@test.com'}}, {'_extra': {'COUNT(`auth_event`.`id`)': 18}, 'auth_event': {'description': 'User 4 Logged-in', 'user_id': 4}, 'auth_user': {'email': 'user2@test.com'}}, {'_extra': {'COUNT(`auth_event`.`id`)': 8}, 'auth_event': {'description': 'User 5 Logged-in', 'user_id': 5}, 'auth_user': {'email': 'user3@test.com'}}, {'_extra': {'COUNT(`auth_event`.`id`)': 22}, 'auth_event': {'description': 'User 6 Logged-in', 'user_id': 6}, 'auth_user': {'email': 'user4@test.com'}}, {'_extra': {'COUNT(`auth_event`.`id`)': 15}, 'auth_event': {'description': 'User 7 Logged-in', 'user_id': 7}, 'auth_user': {'email': 'user5@test.com'}}]
        result = main.convert_login_count('login_count', {'description': '', 'type' : ''}, data, url_server)
        print(result)
        self.assertEqual(result, '# HELP vidjil_api_request_login_count \n# TYPE vidjil_api_request_login_count \nvidjil_api_request_login_count{user_id="1", user_email="plop@plop.com", server="https://localhost/vidjil/"} 3\nvidjil_api_request_login_count{user_id="3", user_email="user1@test.com", server="https://localhost/vidjil/"} 14\nvidjil_api_request_login_count{user_id="4", user_email="user2@test.com", server="https://localhost/vidjil/"} 18\nvidjil_api_request_login_count{user_id="5", user_email="user3@test.com", server="https://localhost/vidjil/"} 8\nvidjil_api_request_login_count{user_id="6", user_email="user4@test.com", server="https://localhost/vidjil/"} 22\nvidjil_api_request_login_count{user_id="7", user_email="user5@test.com", server="https://localhost/vidjil/"} 15\n')

    def test_convert_login_count_2(self):
        url_server = "https://localhost/vidjil/"
        data = [{'_extra': {'COUNT(`auth_event`.`id`)': 3}, 'auth_event': {'description': 'User 1 Logged-in', 'user_id': 1}, 'auth_user': {'email': 'plop@plop.com'}}]
        result = main.convert_login_count('login_count', {'description': '', 'type' : ''}, data, url_server)
        print(result)
        self.assertEqual(result, '# HELP vidjil_api_request_login_count \n# TYPE vidjil_api_request_login_count \nvidjil_api_request_login_count{user_id="1", user_email="plop@plop.com", server="https://localhost/vidjil/"} 3\n')

    def test_convert_login_count_3(self):
        url_server = "https://localhost/vidjil/"
        data = [{'_extra': {'COUNT(`auth_event`.`id`)': 0}, 'auth_event': {'description': 'User 1 Logged-in', 'user_id': 1}, 'auth_user': {'email': 'plop@plop.com'}}]
        result = main.convert_login_count('login_count', {'description': '', 'type' : ''}, data, url_server)
        print(result)
        self.assertEqual(result, '# HELP vidjil_api_request_login_count \n# TYPE vidjil_api_request_login_count \nvidjil_api_request_login_count{user_id="1", user_email="plop@plop.com", server="https://localhost/vidjil/"} 0\n')
        
    def test_convert_configs_analysis(self):
        url_server = "https://localhost/vidjil/"
        data = [{'_extra': {'COUNT(`results_file`.`id`)': 64}, 'config': {'name': 'default + extract reads', 'program': 'vidjil'}, 'results_file': {'config_id': 1}}, {'_extra': {'COUNT(`results_file`.`id`)': 15}, 'config': {'name': 'multi+inc+xxx', 'program': 'vidjil'}, 'results_file': {'config_id': 2}}, {'_extra': {'COUNT(`results_file`.`id`)': 13}, 'config': {'name': 'multi+inc', 'program': 'vidjil'}, 'results_file': {'config_id': 3}}, {'_extra': {'COUNT(`results_file`.`id`)': 18}, 'config': {'name': 'multi', 'program': 'vidjil'}, 'results_file': {'config_id': 4}}, {'_extra': {'COUNT(`results_file`.`id`)': 11}, 'config': {'name': 'TRG', 'program': 'vidjil'}, 'results_file': {'config_id': 5}}]
        result = main.convert_configs_analysis('config_analysis', {'description': '', 'type' : ''}, data, url_server)
        print(result)
        self.assertEqual(result, '# HELP vidjil_api_request_config_analysis \n# TYPE vidjil_api_request_config_analysis \nvidjil_api_request_config_analysis{config_name="default _ extract reads", config_program="vidjil", config_id="1", server="https://localhost/vidjil/"} 64\nvidjil_api_request_config_analysis{config_name="multi_inc_xxx", config_program="vidjil", config_id="2", server="https://localhost/vidjil/"} 15\nvidjil_api_request_config_analysis{config_name="multi_inc", config_program="vidjil", config_id="3", server="https://localhost/vidjil/"} 13\nvidjil_api_request_config_analysis{config_name="multi", config_program="vidjil", config_id="4", server="https://localhost/vidjil/"} 18\nvidjil_api_request_config_analysis{config_name="TRG", config_program="vidjil", config_id="5", server="https://localhost/vidjil/"} 11\n')

    def test_convert_configs_analysis_by_groups(self):
        url_server = "https://localhost/vidjil:8000/"
        data = [{'_extra': {'COUNT(`results_file`.`id`)': 15}, 'auth_group': {'role': 'admin'}, 'config': {'name': 'default + extract reads', 'program': 'vidjil'}, 'results_file': {'config_id': 1}}, {'_extra': {'COUNT(`results_file`.`id`)': 15}, 'auth_group': {'role': 'user_0001'}, 'config': {'name': 'default + extract reads', 'program': 'vidjil'}, 'results_file': {'config_id': 1}}, {'_extra': {'COUNT(`results_file`.`id`)': 130}, 'auth_group': {'role': 'public'}, 'config': {'name': 'default + extract reads', 'program': 'vidjil'}, 'results_file': {'config_id': 1}}, {'_extra': {'COUNT(`results_file`.`id`)': 25}, 'auth_group': {'role': 'user_0003'}, 'config': {'name': 'multi+inc+xxx', 'program': 'vidjil'}, 'results_file': {'config_id': 2}}, {'_extra': {'COUNT(`results_file`.`id`)': 23}, 'auth_group': {'role': 'user_0003'}, 'config': {'name': 'default + extract reads', 'program': 'vidjil'}, 'results_file': {'config_id': 1}}, {'_extra': {'COUNT(`results_file`.`id`)': 22}, 'auth_group': {'role': 'user_0003'}, 'config': {'name': 'multi', 'program': 'vidjil'}, 'results_file': {'config_id': 4}}, {'_extra': {'COUNT(`results_file`.`id`)': 21}, 'auth_group': {'role': 'user_0003'}, 'config': {'name': 'multi+inc', 'program': 'vidjil'}, 'results_file': {'config_id': 3}}, {'_extra': {'COUNT(`results_file`.`id`)': 25}, 'auth_group': {'role': 'user_0003'}, 'config': {'name': 'TRG', 'program': 'vidjil'}, 'results_file': {'config_id': 5}}, {'_extra': {'COUNT(`results_file`.`id`)': 138}, 'auth_group': {'role': 'public'}, 'config': {'name': 'multi+inc+xxx', 'program': 'vidjil'}, 'results_file': {'config_id': 2}}, {'_extra': {'COUNT(`results_file`.`id`)': 128}, 'auth_group': {'role': 'public'}, 'config': {'name': 'multi', 'program': 'vidjil'}, 'results_file': {'config_id': 4}}, {'_extra': {'COUNT(`results_file`.`id`)': 111}, 'auth_group': {'role': 'public'}, 'config': {'name': 'multi+inc', 'program': 'vidjil'}, 'results_file': {'config_id': 3}}, {'_extra': {'COUNT(`results_file`.`id`)': 125}, 'auth_group': {'role': 'public'}, 'config': {'name': 'TRG', 'program': 'vidjil'}, 'results_file': {'config_id': 5}}, {'_extra': {'COUNT(`results_file`.`id`)': 34}, 'auth_group': {'role': 'user_0004'}, 'config': {'name': 'multi', 'program': 'vidjil'}, 'results_file': {'config_id': 4}}, {'_extra': {'COUNT(`results_file`.`id`)': 27}, 'auth_group': {'role': 'user_0004'}, 'config': {'name': 'TRG', 'program': 'vidjil'}, 'results_file': {'config_id': 5}}, {'_extra': {'COUNT(`results_file`.`id`)': 33}, 'auth_group': {'role': 'user_0004'}, 'config': {'name': 'multi+inc+xxx', 'program': 'vidjil'}, 'results_file': {'config_id': 2}}, {'_extra': {'COUNT(`results_file`.`id`)': 22}, 'auth_group': {'role': 'user_0004'}, 'config': {'name': 'default + extract reads', 'program': 'vidjil'}, 'results_file': {'config_id': 1}}, {'_extra': {'COUNT(`results_file`.`id`)': 25}, 'auth_group': {'role': 'user_0004'}, 'config': {'name': 'multi+inc', 'program': 'vidjil'}, 'results_file': {'config_id': 3}}, {'_extra': {'COUNT(`results_file`.`id`)': 28}, 'auth_group': {'role': 'user_0005'}, 'config': {'name': 'TRG', 'program': 'vidjil'}, 'results_file': {'config_id': 5}}, {'_extra': {'COUNT(`results_file`.`id`)': 25}, 'auth_group': {'role': 'user_0005'}, 'config': {'name': 'multi', 'program': 'vidjil'}, 'results_file': {'config_id': 4}}, {'_extra': {'COUNT(`results_file`.`id`)': 31}, 'auth_group': {'role': 'user_0005'}, 'config': {'name': 'multi+inc+xxx', 'program': 'vidjil'}, 'results_file': {'config_id': 2}}, {'_extra': {'COUNT(`results_file`.`id`)': 26}, 'auth_group': {'role': 'user_0005'}, 'config': {'name': 'default + extract reads', 'program': 'vidjil'}, 'results_file': {'config_id': 1}}, {'_extra': {'COUNT(`results_file`.`id`)': 21}, 'auth_group': {'role': 'user_0005'}, 'config': {'name': 'multi+inc', 'program': 'vidjil'}, 'results_file': {'config_id': 3}}, {'_extra': {'COUNT(`results_file`.`id`)': 21}, 'auth_group': {'role': 'user_0006'}, 'config': {'name': 'multi+inc', 'program': 'vidjil'}, 'results_file': {'config_id': 3}}, {'_extra': {'COUNT(`results_file`.`id`)': 27}, 'auth_group': {'role': 'user_0006'}, 'config': {'name': 'TRG', 'program': 'vidjil'}, 'results_file': {'config_id': 5}}, {'_extra': {'COUNT(`results_file`.`id`)': 25}, 'auth_group': {'role': 'user_0006'}, 'config': {'name': 'multi+inc+xxx', 'program': 'vidjil'}, 'results_file': {'config_id': 2}}, {'_extra': {'COUNT(`results_file`.`id`)': 25}, 'auth_group': {'role': 'user_0006'}, 'config': {'name': 'multi', 'program': 'vidjil'}, 'results_file': {'config_id': 4}}, {'_extra': {'COUNT(`results_file`.`id`)': 14}, 'auth_group': {'role': 'user_0006'}, 'config': {'name': 'default + extract reads', 'program': 'vidjil'}, 'results_file': {'config_id': 1}}, {'_extra': {'COUNT(`results_file`.`id`)': 22}, 'auth_group': {'role': 'user_0007'}, 'config': {'name': 'multi', 'program': 'vidjil'}, 'results_file': {'config_id': 4}}, {'_extra': {'COUNT(`results_file`.`id`)': 18}, 'auth_group': {'role': 'user_0007'}, 'config': {'name': 'TRG', 'program': 'vidjil'}, 'results_file': {'config_id': 5}}, {'_extra': {'COUNT(`results_file`.`id`)': 23}, 'auth_group': {'role': 'user_0007'}, 'config': {'name': 'multi+inc', 'program': 'vidjil'}, 'results_file': {'config_id': 3}}, {'_extra': {'COUNT(`results_file`.`id`)': 24}, 'auth_group': {'role': 'user_0007'}, 'config': {'name': 'multi+inc+xxx', 'program': 'vidjil'}, 'results_file': {'config_id': 2}}, {'_extra': {'COUNT(`results_file`.`id`)': 30}, 'auth_group': {'role': 'user_0007'}, 'config': {'name': 'default + extract reads', 'program': 'vidjil'}, 'results_file': {'config_id': 1}}]
        result = main.convert_configs_analysis('config_analysis', {'description': '', 'type' : ''}, data, url_server)
        print(result)
        self.assertEqual(result, '# HELP vidjil_api_request_config_analysis_by_groups configs_analysis.\n# TYPE vidjil_api_request_config_analysis_by_groups gauge\nvidjil_api_request_config_analysis_by_groups{config_name="default _ extract reads", config_program="vidjil", config_id="1", group="admin", server="https://localhost:8000/vidjil/"} 15\nvidjil_api_request_config_analysis_by_groups{config_name="default _ extract reads", config_program="vidjil", config_id="1", group="user_0001", server="https://localhost:8000/vidjil/"} 15\nvidjil_api_request_config_analysis_by_groups{config_name="default _ extract reads", config_program="vidjil", config_id="1", group="public", server="https://localhost:8000/vidjil/"} 130\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc_xxx", config_program="vidjil", config_id="2", group="user_0003", server="https://localhost:8000/vidjil/"} 25\nvidjil_api_request_config_analysis_by_groups{config_name="default _ extract reads", config_program="vidjil", config_id="1", group="user_0003", server="https://localhost:8000/vidjil/"} 23\nvidjil_api_request_config_analysis_by_groups{config_name="multi", config_program="vidjil", config_id="4", group="user_0003", server="https://localhost:8000/vidjil/"} 22\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc", config_program="vidjil", config_id="3", group="user_0003", server="https://localhost:8000/vidjil/"} 21\nvidjil_api_request_config_analysis_by_groups{config_name="TRG", config_program="vidjil", config_id="5", group="user_0003", server="https://localhost:8000/vidjil/"} 25\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc_xxx", config_program="vidjil", config_id="2", group="public", server="https://localhost:8000/vidjil/"} 138\nvidjil_api_request_config_analysis_by_groups{config_name="multi", config_program="vidjil", config_id="4", group="public", server="https://localhost:8000/vidjil/"} 128\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc", config_program="vidjil", config_id="3", group="public", server="https://localhost:8000/vidjil/"} 111\nvidjil_api_request_config_analysis_by_groups{config_name="TRG", config_program="vidjil", config_id="5", group="public", server="https://localhost:8000/vidjil/"} 125\nvidjil_api_request_config_analysis_by_groups{config_name="multi", config_program="vidjil", config_id="4", group="user_0004", server="https://localhost:8000/vidjil/"} 34\nvidjil_api_request_config_analysis_by_groups{config_name="TRG", config_program="vidjil", config_id="5", group="user_0004", server="https://localhost:8000/vidjil/"} 27\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc_xxx", config_program="vidjil", config_id="2", group="user_0004", server="https://localhost:8000/vidjil/"} 33\nvidjil_api_request_config_analysis_by_groups{config_name="default _ extract reads", config_program="vidjil", config_id="1", group="user_0004", server="https://localhost:8000/vidjil/"} 22\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc", config_program="vidjil", config_id="3", group="user_0004", server="https://localhost:8000/vidjil/"} 25\nvidjil_api_request_config_analysis_by_groups{config_name="TRG", config_program="vidjil", config_id="5", group="user_0005", server="https://localhost:8000/vidjil/"} 28\nvidjil_api_request_config_analysis_by_groups{config_name="multi", config_program="vidjil", config_id="4", group="user_0005", server="https://localhost:8000/vidjil/"} 25\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc_xxx", config_program="vidjil", config_id="2", group="user_0005", server="https://localhost:8000/vidjil/"} 31\nvidjil_api_request_config_analysis_by_groups{config_name="default _ extract reads", config_program="vidjil", config_id="1", group="user_0005", server="https://localhost:8000/vidjil/"} 26\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc", config_program="vidjil", config_id="3", group="user_0005", server="https://localhost:8000/vidjil/"} 21\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc", config_program="vidjil", config_id="3", group="user_0006", server="https://localhost:8000/vidjil/"} 21\nvidjil_api_request_config_analysis_by_groups{config_name="TRG", config_program="vidjil", config_id="5", group="user_0006", server="https://localhost:8000/vidjil/"} 27\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc_xxx", config_program="vidjil", config_id="2", group="user_0006", server="https://localhost:8000/vidjil/"} 25\nvidjil_api_request_config_analysis_by_groups{config_name="multi", config_program="vidjil", config_id="4", group="user_0006", server="https://localhost:8000/vidjil/"} 25\nvidjil_api_request_config_analysis_by_groups{config_name="default _ extract reads", config_program="vidjil", config_id="1", group="user_0006", server="https://localhost:8000/vidjil/"} 14\nvidjil_api_request_config_analysis_by_groups{config_name="multi", config_program="vidjil", config_id="4", group="user_0007", server="https://localhost:8000/vidjil/"} 22\nvidjil_api_request_config_analysis_by_groups{config_name="TRG", config_program="vidjil", config_id="5", group="user_0007", server="https://localhost:8000/vidjil/"} 18\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc", config_program="vidjil", config_id="3", group="user_0007", server="https://localhost:8000/vidjil/"} 23\nvidjil_api_request_config_analysis_by_groups{config_name="multi_inc_xxx", config_program="vidjil", config_id="2", group="user_0007", server="https://localhost:8000/vidjil/"} 24\nvidjil_api_request_config_analysis_by_groups{config_name="default _ extract reads", config_program="vidjil", config_id="1", group="user_0007", server="https://localhost:8000/vidjil/"} 30\n')
    
